---
title: PositionSensorVRDevice.getState()
slug: Web/API/PositionSensorVRDevice/getState
tags:
  - API
  - Experimental
  - Expérimental(2)
  - Method
  - Obsolete
  - PositionSensorVRDevice
  - Reference
  - Référence(2)
  - VR
  - Virtual Reality
  - WebVR
---
<div>{{obsolete_header()}}{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>getState()</code></strong> method of the {{domxref("PositionSensorVRDevice")}} interface returns the current state of the position sensor for the current frame (e.g. within the current {{domxref("window.requestAnimationFrame")}} callback) or for the previous frame, contained with a {{domxref("VRPositionState")}} object. This is the method you'd normally want to use, vs. {{domxref("PositionSensorVRDevice.getImmediateState")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var myPositionState = PositionSensorVRDevice.getState();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Returns">Returns</h3>

<p>A {{domxref("VRPositionState")}} object.</p>

<h2 id="Examples">Examples</h2>

<p>The following example is taken from our <a href="https://mdn.github.io/webvr-tests/positionsensorvrdevice/">positionsensorvrdevice</a> demo, which uses the WebVR API to update the view of a simple {{domxref("CanvasRenderingContext2D","2D canvas")}} scene on each frame of a {{domxref("window.requestAnimationFrame()","requestAnimationFrame")}} loop.</p>

<pre class="brush: js">function setView() {
  var posState = gPositionSensor.getState();
  if(posState.hasPosition) {
    posPara.textContent = 'Position: x' + roundToTwo(posState.position.x) + " y"
                                + roundToTwo(posState.position.y) + " z"
                                + roundToTwo(posState.position.z);
    xPos = -posState.position.x * WIDTH * 2;
    yPos = posState.position.y * HEIGHT * 2;
    if(-posState.position.z &gt; 0.01) {
      zPos = -posState.position.z;
    } else {
      zPos = 0.01;
    }
  }

  if(posState.hasOrientation) {
    orientPara.textContent = 'Orientation: x' + roundToTwo(posState.orientation.x) + " y"
                                + roundToTwo(posState.orientation.y) + " z"
                                + roundToTwo(posState.orientation.z);
    xOrient = posState.orientation.x * WIDTH;
    yOrient = -posState.orientation.y * HEIGHT * 2;
    zOrient = posState.orientation.z * 180;

  }
}</pre>

<p>Here we are grabbing a {{domxref("VRPositionState")}} object using <code>getState()</code> and storing it in <code>posState</code>. We then check to make sure that position and orientation info is present in the current frame using {{domxref("VRPositionState.hasPosition")}} and {{domxref("VRPositionState.hasOrientation")}} (these return <code>null</code> if, for example the head mounted display is turned off or not pointing at the position sensor, which would cause an error.)</p>

<p>We then output the x, y and z position and orientation values for informational purposes, and use those values to update the <code>xPos</code>, <code>yPos</code>, <code>zPos, </code><code>xOrient</code>, <code>yOrient</code>, and <code>zOrient</code> variables, which are used to update the scene rendering on each frame.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PositionSensorVRDevice.getState")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a>.</li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
